/*
 macos/config.c
  configuration file processing (include'd by shell.c)

  Created: 2009.01.21
  Revised: 2012.02.21

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

extern CFGSTRUCT VideoConfig, DebugConfig;

extern int	rec_wavedepth;
extern char	recentpaths[RECENTPATHSIZE][RECENTMINCOUNT];

#include "../video.h"
#include "../palette.h"

static CFGSTRUCT	macfceuconfig[] =
{
	AC(ntsccol),AC(ntsctint),AC(ntschue),AC(ntscbrt),

	AC(maxconbskip),
	AC(ffbskip),

	AC(palyo),
	AC(genie),
	NAC("fs",fullscreen),
	AC(screenshift),
	NAC("vsync",screenrefreshsync),
	ACA(cpalette),
	NACA(nout,CalcPOutscales),
	NACA(ndiq,CalcPDecodeIQ),

	ADDCFGSTRUCT(VideoConfig),

	/* 2009.12.27 */
	ACA(tileviewcolors),
	NAC("bgbl",PPUvoidcolor),
	NAC("wdepth",rec_wavedepth),
	AC(logtofile),
	ADDCFGSTRUCT(DebugConfig),

	NAC("pitchfix",ConsolePitchFix),
	NAC("emuspeed",EmulationSpeedRatio),

	AC(soundrate),
	AC(soundvolume),
	AC(soundquality),
	NAC("recamp",rectangle_amp),
	AC(noise_amp),
	NAC("activechan",sndactivechannels),

	AC(eoptions),

	ADDCFGSTRUCT(InputConfig),

	/* 2012.02.16 */
	ACA(recentpaths),

	ENDCFGSTRUCT
};

static void configfile_save(char *filename)
{
	FCEUI_GetNTSCTHB(&ntsctint,&ntschue,&ntscbrt); /*update from internal*/

	SaveFCEUConfig(filename,macfceuconfig);
}

static void configfile_load(char *filename)
{
	FCEUI_GetNTSCTHB(&ntsctint,&ntschue,&ntscbrt);

	LoadFCEUConfig(filename,macfceuconfig);

	FCEUI_SetNTSCTHB(ntsccol,ntsctint,ntschue,ntscbrt);
}
