/*
 macos/debugger.h

  Created: 2008.08.06
  Revised: 2010.04.17
*/

#ifdef __MACWINDOWS__
 extern WindowRef debuggerwindow;
#endif

/* ---- constants */

 /* FCEUI_DebuggerBreak user flags (bit #8 and above of opc) */

#define _DBreak_nosave		0x8000	/* savecurrent is denied */
#define _DBreak_noillegal	0x4000	/* illegal instruction returns constant */
#define _DBreak_noshow		0x2000	/* don't show the debugger */
#define _DBreak_nobreakpoint	0x1000	/* deny breakpoints from this call */
#define _DBreak_bypassbpt	0x0800	/* bypass, return this constant */

/* ---- prototypes */

boolean debuggerwindow_visible(void); /* added; 2010.03.27 */
int debuggerwindow_show(int show); /* negative to toggle */
int debuggerwindow_update(boolean erase);
void debuggerwindow_activate(boolean activate);
int debuggerwindow_grow(const struct EventRecord *event);
int debuggerwindow_click(const struct EventRecord *event);

int debuggerwindow_step(int count);
int debuggerwindow_clear(boolean update); /* clears window, breakpoints */
