/*
 macos/macgeneral.h (formerly macglue.h)

  Created: 2008.08.12
  Revised: 2010.04.19
*/

#ifndef __MACGENERAL_H
 #pragma once

/* ---- prototypes */

 const void *memrchr(const void *s,
	int c,
	size_t z);

/* copies source to destination, max is maximum length, clipped to 255 */
 unsigned char *cpstrcpy(void *d,
	const void *s,
	unsigned short max);

/* memory remap */
 void memrem(void *p,
	long c,
	const unsigned char *t);

/* memcpy16 exists for performance reasons; 16-byte boundaries (low 4 bits ignored) */
 void memcpy16(void *d,
	const void *s,
	long z);

/* just like GetIndString, but the index is zero-based */
 unsigned char *getpstr(void *d,
	short strlistid,
	int x);
 int getcstr(char *d,
	short strlistid,
	int x);
 int countstrlist(short strlistid);

 #define __MACGENERAL_H
#endif
