/*
 utility/asm6502.h

 * MacFCEU 0.6a4
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define _IntoLine	0x80	/* otherwise start of line */

typedef struct _asm6502frame
{
	uint16		org;
	uint16		addr;
	uint8		flag;
	/*  Because the hash-byte defines whether there is a next string, a */
	/* char length of zero for the Pascal string is instead 256 chars. */
	uint8		*labels; /* null term'd list of hash, x-P-string */
} _asm6502frame;

/* returns offset or negative (error) */
int32 X6502_AsmGetID(const char *s,
	const char *e,
	const _asm6502frame *f);
int X6502_AsmAddID(const char *s,
	const char *e,
	_asm6502frame *f)

/* returns either negative (error), positive when finished */
int X6502_Assemble(const char *src, /* C-string - must have complete lines */
	int (*writef)(uint16 addr, uint8 byte), /* can be NULL (check syntax) */
	_asm6502frame *fmem); /* can be NULL (one call); zero it out first thing */
