/*
 evaluate.h
  the evaluation switch for interpreter v1.4d6
*/
#ifndef _OPC
 #define _OPC(m)		case _op_##m:
#endif
_OPC(expr)
	if (!(o&0x80))
		goto end;
	/* set */
	a = unpack_eval(s);
	s-= sizeof(evalvalue);
	/* b would hold reference for the destination but the
	 current implementation doesn't allow this
	*/
	return 0; /* <xstack */
_OPC(ldw) /* load word */
	if (evalindir)
		a = evalindir(b);
	break;
_OPC(srt) a = esqrt(b); break; /* square root */
_OPC(abs) a = b>=0 ? b:-b; break;
_OPC(neg) a =-b; break;
_OPC(not) a =~(long)b; break; /* binary NOT */
_OPC(bno) a = !b; break; /* boolean NOT */
/* dyadic */
_OPC(ban) a = a && b; break; /* bool. AND */
_OPC(bor) a = a || b; break; /* bool. OR */
_OPC(and) a = (long)a&(long)b; break;
_OPC(ior) a = (long)a|(long)b; break; /* bin. OR */
_OPC(eor) a = (long)a^(long)b; break; /* bin. Exclusive-OR */
_OPC(asr) a = (long)a>>(long)b; break; /* arithmetic shift right */
_OPC(shr) /* logical shift right */
#if EVAL_FLOATING
	a = scalb(a,-(long)b);
#else
	a = (unsigned)a>>(unsigned)b;
#endif
	break;
_OPC(shl) /* log. shift left */
#if EVAL_FLOATING
	a = scalb(a,(long)b);
#else
	a = (unsigned)a<<(unsigned)b;
#endif
	break;
_OPC(add) a+= b; break;
_OPC(sub) a-= b; break; /* subtract */
_OPC(mul) a = (evalsing)a*(evalsing)b; break; /* multiply */
_OPC(pow) a = epow(a,b); break; /* exponentiation */
_OPC(div) /* division */
#if EVAL_FLOATING
	a/= b;
#else
	a = !b ? -1U:(unsigned)a/(unsigned)b;
#endif
	break;
_OPC(dvs) /* signed div. */
	a = !b ? EVAL_HUGEVAL:(signed)(a/b);
	break;
_OPC(mod) /* modulus */
#if EVAL_FLOATING
	a = fmod(a,b);
#else
	a = !b ? 0:(unsigned)a%(unsigned)b;
#endif
	break;
_OPC(mds) a = !b ? 0:(signed)a%(signed)b; break; /* signed mod. */
_OPC(clt) a = a<b; break; /* lesser */
_OPC(cge) a = a>=b; break; /* greater or equal */
_OPC(cgt) a = a>b; break; /* greater */
_OPC(cle) a = a<=b; break; /* lesser or equal */
_OPC(ceq) a = a==b; break; /* equal */
_OPC(cne) a = a!=b; break; /* not equal */
_OPC(cid) a = !memcmp(&a,&b,sizeof(a)); break; /* identical */
_OPC(cni) a = !!memcmp(&a,&b,sizeof(a)); break; /* not identical */
